<?php
include ("jpgraph/src/jpgraph.php");
#include ("jpgraph/src/jpgraph_bar.php");
include ("jpgraph/src/jpgraph_log.php");
include ("jpgraph/src/jpgraph_scatter.php");
include ("jpgraph/src/jpgraph_line.php");


// Create the graph. These two calls are always required
$graph = new Graph(600, 300, "auto", 10);
$graph->SetScale("textlog");
$graph->SetShadow();
$graph->img->SetMargin(50,20,30,35);
$graph->title->Set("User in den letzten 31 Tagen      ");
#$graph->yaxis->title->Set("Zugriffe/Tag");

$graph->ygrid->Show(true,true);
$graph->xgrid->Show(true,false);

include("php/initfunctions.php");




for ($i = 0; $i < 32; $i++) {
    $data1y[] = 0;
}

$data2y = $data1y;

$usercount = array();
$teamcount = array();
$query = "SELECT (TO_DAYS(NOW()) - TO_DAYS(FROM_UNIXTIME(timestamp))) AS day FROM " . $GLOBALS["table_hits"] . " WHERE type=1 AND timestamp>= " . (mktime(0,0,0,date("m"),date("d")-31,date("Y"))) . " GROUP BY day, abs(entryID)  ORDER BY day";
#	echo $query . "<br/>\n";
# WHERE type=1 AND timestamp >= " . $lastactivedate
$result = mysql_db_query($GLOBALS["db"], $query);
if(!$result) {
    echo "<color=red>Fehler: " . mysql_error() . "<br/>\n</color>\n";
} else {
    while($row = mysql_fetch_array($result)) {
    
        $data1y[31-$row["day"]] ++;
    }
}


$query = "SELECT FLOOR(timestamp / 86400.0) AS day, COUNT(*) AS count FROM " . $GLOBALS["table_users"] . " GROUP BY day ORDER BY day";
#	echo $query . "<br/>\n";
# WHERE type=1 AND timestamp >= " . $lastactivedate
$result = mysql_db_query($GLOBALS["db"], $query);
if(!$result) {
    echo "<color=red>Fehler: " . mysql_error() . "<br/>\n</color>\n";
} else {
    $daynow = floor(time() / 86400.0);
    $usercount = 0;
    while($row = mysql_fetch_array($result)) {
	if($usercount == 0) {
	    $usercount = $row["count"];
	    $data2y[0] = $row["count"];
	} else {
	    $usercount += $row["count"];
	    if($daynow - $row["day"] <= 31) {
		$data2y[31 - ($daynow - $row["day"])] = $usercount;
	    }
	}
    }
}


for ($i = 0; $i < 32; $i++) {
    if($data2y[$i] == 0) {
	$data2y[$i] = $lastvalue;
    } else {
	$lastvalue = $data2y[$i];
    }
}



// Create the active user bar plots
#$b1plot = new BarPlot($data1y);
#$b1plot->SetFillGradient("mediumpurple4","lavender",GRAD_MIDVER);
#$b1plot->SetColor("mediumpurple4");
#$b1plot->SetFillColor("lavender");
#$b1plot->SetWidth(0.7);
#$b1plot->SetLegend("aktiv");


#$sp1 = new ScatterPlot($data1y);
#$sp1->mark->SetType(MARK_SQUARE);
#$sp1->SetImpuls();
#$sp1->SetLegend("aktiv");


$lp2 = new LinePlot($data1y);
$lp2->SetFillColor("orange");
$lp2->SetStepStyle();
$lp2->SetLegend("aktiv");


// Create the registered users line plot
$l1plot=new LinePlot($data2y);
$l1plot->SetColor("red");
#$l1plot->SetWeight(2);
$l1plot->SetStepStyle();
# $l1plot->SetBarCenter();
$l1plot->SetLegend("registriert");


// ...and add them to the graph
$graph->Add($lp2);
$graph->Add($l1plot);



$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

$d = date("d");
$m = date("m");
$y = date("Y");
for($i=31; $i > 0; $i--) {
    $ticks[] = date("j.m.", mktime(0,0,0,$m,($d-$i),$y));
}

$graph->xaxis->SetTickLabels($ticks);
$graph->xaxis->SetTextLabelInterval(3);

$graph->legend->Pos(0.05, 0.01, 'right','top');
$graph->legend->SetLayout(LEGEND_HOR); 

// Display the graph
$graph->Stroke();
?>
