<?php
include ("jpgraph/src/jpgraph.php");
include ("jpgraph/src/jpgraph_bar.php");

// Create the graph. These two calls are always required
$graph = new Graph(600, 300, "auto", 1);
$graph->SetScale("textlin");
$graph->SetShadow();
$graph->img->SetMargin(50,20,30,35);
$graph->title->Set("Zugriffe in den letzten 24 Stunden");
#$graph->yaxis->title->Set("Zugriffe/Tag");


include("php/initfunctions.php");




for ($i = 0; $i <= 23; $i++) {
    $data1y[] = 0;
}

$usercount = array();
$teamcount = array();
$query = "SELECT FROM_UNIXTIME(timestamp, '%k') AS hour, type, COUNT(*) AS count FROM " . $GLOBALS["table_hits"] . " WHERE timestamp >= " . mktime(date("H")+1,0,0,date("m"), date("d")-1,date("Y")) . " AND type=3 GROUP BY hour ORDER BY timestamp";
#	echo $query . "<br/>\n";
# WHERE type=1 AND timestamp >= " . $lastactivedate
$result = mysql_db_query($GLOBALS["db"], $query);
if(!$result) {
    echo "<color=red>Fehler: " . mysql_error() . "<br/>\n</color>\n";
} else {
    $h = date("H");
    while($row = mysql_fetch_array($result)) {
	$r = (23 - $h + $row["hour"]) % 24;
	$data1y[$r] += $row["count"];
    }
}




// Create the bar plots
$b1plot = new BarPlot($data1y);
$b1plot->SetFillGradient("yellow4","white",GRAD_MIDVER);
$b1plot->SetColor("yellow4");
$b1plot->SetFillColor("yellow");
$b1plot->SetWidth(0.7);


// ...and add it to the graPH
$graph->Add($b1plot);



$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

$h = date("H");
for($i=0; $i < 24; $i++) {
    $ticks[] = str_pad(($i + $h +1) % 24, 2, '0', STR_PAD_LEFT);
}

$graph->xaxis->SetTickLabels($ticks);


$graph->legend->Pos(0.05, 0.01, 'right','top');
$graph->legend->SetLayout(LEGEND_HOR); 

// Display the graph
$graph->Stroke();
?>
