<?php
    require_once("php/prepend.php");
    
    // search for last title in  news.xml
    // we need the xml parser
    require_once("./php/kxparse.php");
	    
    //load the file into the parser: constructor(string file)
    $xml_news=new kxparse("news.xml");
    
    $count = $xml_news->count_tag("news:item", "1:?");
    for($n=1; (($n <= $count) && (strlen($msg)==0)); $n++) {
	$msg = nl2br(htmlentities($xml_news->get_tag_text("news:item:title","1:" . $n . ":1")));
	$date = $xml_news->get_tag_text("news:item:date","1:" . $n . ":1");
    }
    
    
?>
<html>
 <head>
  <title>SetiStats - die Seticounter</title>
  <!-- meta tags -->
  <?php
    $found = false;
    $lang = explode(",", getenv("HTTP_ACCEPT_LANGUAGE"));
    for($n = 0; ($n < count($lang)) && (!$found); $n++) {
	if(strpos($lang[$n], "de") !== false) {
	    $meta_desc = $meta_description_de;
	    $meta_keys = $meta_keywords . ", " . $meta_keywords_de;
	    $found = true;
	} else if(strpos($lang[$n], "fr") !== false) {
	    $meta_desc = $meta_description_fr;
	    $meta_keys = $meta_keywords . ", " . $meta_keywords_fr;
	    $found = true;
	} else if(strpos($lang[$n], "en") !== false) {
	    $meta_desc = $meta_description_en;
	    $meta_keys = $meta_keywords . ", " . $meta_keywords_en;
	    $found = true;
	} else {
	}
    }
    
    if(!$found) {
	# keine Sprache gefunden
	$meta_desc = $meta_description_en;
	$meta_keys = $meta_keywords . ", " . $meta_keywords_en;
    }
    
  ?><meta name="description" content="<?php echo htmlentities($meta_desc); ?>">
  <meta name="author" content="<?php echo htmlentities($meta_author); ?>">
  <meta name="keywords" content="<?php echo htmlentities($meta_keys); ?>">
  <!-- end meta tags -->
  
  <link href="style.css" rel="stylesheet" type="text/css" />
  
 </head>

 <body>
 
 

  <!-- body table -->
  <table align="center" valign="top" border="0" cellpadding="8" cellspacing="0" width="85%">
   <!-- top header -->
   <tr>
    <td valign="center" width="25%" colspan="2">
    <?php
        @include("header.inc.php");
    ?>
    </td>
   </tr>
   <!-- end top header -->
 
   <tr>
    <!-- left column -->
    <td valign="top" width="25%">
     <?php
        require("navigation.inc.php");
     ?>
     <br />

     <!-- sidebox -->
     <table bgcolor="#000000" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td>
        <table border="0" cellpadding="3" cellspacing="1" width="100%">
         <tr>
          <td bgcolor="#cccccc">
           &nbsp;<span class="title">Links</span>
          </td>
         </tr>
         <tr>
          <td bgcolor="#ffffff">
           &nbsp;<span class="small">o</span>
           <a class="nav" href="redirect.php?url=www.setiathome.com" target="_blank">Seti@home</a>
           <br />
           &nbsp;<span class="small">o</span>
           <a class="nav" href="redirect.php?url=counter.amanheis.de/" target="_blank">Amanheis</a>
           <br />
	   &nbsp;<span class="small">o</span>
	   <a class="nav" target="_blank" href="redirect.php?url=seti.familie-friedrich.de">Jesus</a>
	   <br/>
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
     <!-- end sidebox -->
    
    </td>
    <!-- end left column -->

    <!-- right column -->
    <td valign="top" width="75%">
     <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td valign="top" width="100%">

        <!-- story -->
        <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
         <tr>
          <td>
           <table border="0" cellpadding="8" cellspacing="1" width="100%">
            <tr>
             <td bgcolor="#ffffff">
	     
	     <p>
	     <?php
	        
	     ?>
	     </p>
	     
              <h2>
               Herzlich Willkommen bei SetiStats.  
              </h2>
	      
	      <?php
	        if(strlen($msg)>0) {
		    echo "<p>Letzte &Auml;nderung:&nbsp;&nbsp;" . format_date($date, "de") . " - <a href=\"news.php\"><b class=\"alert\">" . $msg . "</b></a></p>";
		}
	      ?>
	      
              <p>
               Dies ist die Web-Site von SetiStats, einem freien Einzel- und Gruppen-Counter f&uuml;r das Projekt <a target="_blank" href="redirect.php?url=www.setiathome.com">Seti@Home</a> der Universit&auml;t Berkeley.
              </p>

              <p>
	      <a target="_blank" href="redirect.php?url=www.setiathome.com">Seti@Home</a> befa&szlig;t sich mit der Suche nach Funksignalen aus dem Weltall als Beweis f&uuml;r die Existenz au&szlig;erirdischen Lebens. Um die aufgezeichneten Funksignale analysieren zu k&ouml;nnen, bedient sich die Universit&auml;t von Berkeley dem Prinzip des Distributed Computing, das bedeutet, da&szlig; viele Rechner im Verbund kleine Teile der anfallenden Datenmengen auf Auff&auml;lligkeiten hin untersuchen, die auf das Vorhandensein intelligenter Lebensformen schlie&szlig;en lassen.
              </p>
	      
	      <p>
	       Bei diesem Projekt darf sich jeder anmelden und mitrechnen (sofern es einen Client f&uuml;r seine verwendete Rechnerplattform gibt). 
	      </p>
	      
	      <p>
	       Um nun nicht nur einen einfachen Link auf seine Statistikseite bei <a target="_blank" href="redirect.php?url=www.setiathome.com">Seti@Home</a> auf der eigenen Homepage oder in den verschiedensten Foren anbringen zu m&uuml;ssen, hat <a target="_blank" href="redirect.php?url=seti.familie-friedrich.de">Jesus</a> sich den Seti-Counter von <a target="_blank" href="redirect.php?url=www.amanheis.de">Amanheis.de</a> heruntergeladen und soweit modifiziert, da&szlig; man beliebige Gruppen- und Einzel-Counter definieren kann. Bei <a target="_blank" href="redirect.php?url=www.amanheis.de">Amanheis.de</a> war bis dahin nur ein freier Einzel-Counter m&ouml;glich. 
	      </p>
	      
	      <p>
	      Falls Du das Interesse immer noch nicht verloren hast, so kannst Du Dich &uuml;ber den Index an der Seite weiter zu den Countern vorarbeiten. Ich hoffe doch mal, da&szlig; die Counter euch zufriedenstellen werden. Bei Problemen kannst Du mir einfach eine Mail schicken. Ich werde dann versuchen, Dir bei der L&ouml;sung zu helfen.
	      </p>

              
             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
        <!-- end story -->

        <br />
        <!-- story -->
        <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
         <tr>
          <td>
           <table border="0" cellpadding="8" cellspacing="1" width="100%">
            <tr>
             <td bgcolor="#ffffff" colspan="2" align="center" nowrap="">
              <p align="center">
               Ich selbst bei Seti@Home:
              </p>
	      <p>
	        <img src="userstats.php?bcolor=128,128,128&tcolor=128,128,128&l=2&email=1" border="0">&nbsp;<img src="teamstats.php?bcolor=128,128,128&tcolor=128,128,128&l=2&id=1" border="0">
	      </p>
             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
        <!-- end story -->

       </td>
      </tr>
     </table>
    </td>
    <!-- end right column -->
   </tr>
   <?php
    @include("footer.inc.php");
   ?>
  </table>
  <!-- end body table -->
 </body>
</html>
<?php
    require("php/append.php");
?>