<?php

    if(!isset($FUNCTIONS_LIB_)) {
    
    $FUNCTIONS_LIB_ = "0.1";
    
    
    function printBox_($im, $title, $sponsor, $version)
    {
	imagerectangle($im, 0, 0, $GLOBALS["Width"]-16, $GLOBALS["Height"]-1, $GLOBALS["border_color"]);
	imagerectangle($im, $GLOBALS["Width"]-14, 0,$GLOBALS["Width"]-1, $GLOBALS["Height"]-1, $GLOBALS["border_color"]);
	imagestringup ($im, 3, $GLOBALS["Width"]-14, $GLOBALS["Height"]-3,$title, $GLOBALS["lightblue"]);
	imagestring($im, 1, ($GLOBALS["Width"]-imagefontwidth(1)*strlen($version))-18,($GLOBALS["Height"] - imagefontheight(1) - 1), $version, $GLOBALS["lightgray"]);
	imagestring($im, 1, $GLOBALS["tx"], ($GLOBALS["Height"] - imagefontheight(1) - 1), $sponsor, $GLOBALS["lightblue"]);
    }
	
    
    function printError($im, $headline, $msg, $status="")
    {
	printBox($im);
	
	$charsPerLine = ($GLOBALS["Width"]-17)/imagefontwidth(2);
	
	# headline
	imagestring($im, 3, $GLOBALS["tx"]+1, 1, $headline, $GLOBALS["gray"]);
	imagestring($im, 3, $GLOBALS["tx"],   0, $headline, $GLOBALS["red"]);
	
	#message
	$msgwords = strtok($msg, " ");
	$line = 1;
	$text = "";
	while($msgwords) {
	    if((strlen($text) + strlen($msgwords)) > $charsPerLine) {
		imagestring($im, 2, $GLOBALS["tx"], ($line * 12), $text, $GLOBALS["text_color"]);
		$line++;
		$text = "";
	    }
	    $text .= $msgwords . " ";
	    $msgwords = strtok(" ");
	}
	if(strlen(text) > 0) {
	    imagestring($im, 2, $GLOBALS["tx"], ($line * 12), $text, $GLOBALS["text_color"]);
	}
	imagestring($im, 2, $GLOBALS["tx"],  48, $status, $GLOBALS["text_color"]);
	
	$GLOBALS["error"] = true;
	## Statistik
	## entryID <= 0 zeigt Fehler an ...
	if(isset($GLOBALS["teamID"])) {
	    $entryID = 0 - $GLOBALS["teamID"];
	} else if(isset($GLOBALS["userID"])) {
	    $entryID = 0 - $GLOBALS["userID"];
	} else {
	    $entryID = 0;
	}
	storeHit($GLOBALS["componentID"], $entryID, $GLOBALS["cachedStats"], time() - $GLOBALS["startTime"]);
	# Grafik ausgeben
	imagepng($im);
	## Datenbankverbindung auf jeden Fall schliessen
	@mysql_close($GLOBALS["conn_id"]);
	## beenden
	flush();
	exit();
    }
    
    
    #
    # use the maximum length format for a given time
    #
    function timetostr($t, $maxlen)
    {
    
	setlocale(LC_ALL, $GLOBALS["language_locale"]);
	$locale_info = localeconv();
    
	$oneyear = 365*24*60*60;
	$j = number_format(($t/$oneyear), 2, $locale_info["decimal_point"], $locale_info["thousands_sep"]) . " " . $GLOBALS["str_years"];
	$l = strlen($j);
	if(($l-2)>$maxlen) {
	    $j = number_format(($t/$oneyear), 0, $locale_info["decimal_point"], $locale_info["thousands_sep"]) . " " . $GLOBALS["str_years"];
	} else if(($l-1)>$maxlen) {
	    $j = number_format(($t/$oneyear), 1, $locale_info["decimal_point"], $locale_info["thousands_sep"]) . " " . $GLOBALS["str_years"];
	}
	
	if($t > $oneyear) {
	    return $j;
	} else {

	    $hrs = floor($t/3600);
	    $min = floor(($t-$hrs*3600)/60);
	    $sec = $t - ($hrs*3600) - ($min*60);
	    
	    if($hrs > 0) {
		$h = $hrs . "h";
	    } else {
		$h = "";
	    }
	    
	    $m = " ";
	    if($min < 10) {
		$m .= "0";
	    }
	    $m .= $min . "m";
	    
	    $s = " ";
	    if($sec < 10) {
		$s .= "0";
	    }
	    $s .= number_format($sec, 1, $locale_info["decimal_point"], $locale_info["thousands_sep"]) . "s";
	    
	    $tmp = $h . $m . $s;
	    if(strlen($tmp) <= $maxlen)
		return $tmp;
		
	    $tmp = $h . $m;
	    if(strlen($tmp) <= $maxlen)
		return $tmp;
		
	    if((0 < strlen($h)) AND (strlen($h) <= $maxlen))
		return $tmp;
		
    	    return $j;
	}
    }



    function storeHit($type, $id, $cachedStats, $duration)
    {
	$query = "INSERT INTO " . $GLOBALS["table_hits"] . " (type, entryID, cached, duration, timestamp) VALUES($type, $id, $cachedStats, $duration, " . time() . ")";
	$result = mysql_db_query($GLOBALS["db"], $query);
	if(!$result) {
	    # insert fehlgeschlagen,
	} else {
	}
    }
    
    
    }

?>