<?php


  if(!isset($GLOBALS["USERSTATS_LIB_"]))
  {
    $USERSTATS_LIB_ = 1;
    
    

    require_once("config.inc.php");
    require_once("./php/userdata.class.php");
    
    class UserStats {
    
	var $wu_count, $averagetime, $percentage, $rank;
	var $user;
	var $cachehit = false;
	var $cachedStats = 0;
	var $db_con;
	var $status = 0;
	
	var $conn_id;
	
	var $diffmembers, $diffwus;
	var $diffstats=false;
	
	var $version     = "v0.1.0";
	var $componentID = 1;
	
	var $lock_timestamp = 0;
	
	
	
	var $ERR_READ_SERVER   = 1;
	var $ERR_READ_DB_STATS = 2;
	var $ERR_READ_sdfs     = 3;
	var $ERR_INSERT_STATS1 = 4;
	var $ERR_INSERT_STATS2 = 5;
	var $ERR_NO_USER       = 7;
	var $ERR_NONEXISTING_USER = 8;
	var $ERR_UPDATE_USER   = 9;
	var $ERR_SET_DB_LOCK   = 10;
	var $ERR_REM_DB_LOCK   = 11;
	var $ERR_WRITE_DB_LOCK = 12;
	var $ERR_DELETE_DB_LOCK = 13;
	var $ERR_READ_DB_LOCK = 14;
	
	
	function calcDiffstats() {
	    if($this->diffstats==false) {
		## Bestimmung der maximalen Mitglieder und WUs vom Vortag
		$membersYesterday = 0;
		$wucountYesterday = $wu_count;
		$today        = mktime(0,0,0, date("m"), date("d"), date("Y"));
		$yesterday    = mktime(0,0,0, date("m"), date("d")-1, date("Y"));
		
		$user = $this->getUser();
		$query = "SELECT MAX(wu_count) AS maxwucount FROM " . $GLOBALS["table_userstats"] . " WHERE user_ID=" . $user->getID() . " AND timestamp>" . $yesterday . " AND timestamp<" . $today . "";
		$result = mysql_db_query($GLOBALS["db"], $query);
		if (!$result) {
		    $this->status = $this->ERR_READ_DB__STATS;
		    $this->mysql_errno = mysql_errno();
		    $this->mysql_error = mysql_error();
		    $this->errorline   = "calcDiffs()";
		    $this->diffwus = "N/A";
		} else {
		    if(mysql_num_rows($result) != 0) {
			$row = mysql_fetch_row($result);
			$wucountYesterday = $row[0];
		    }
		}

		if($wucountYesterday <= 0) {
		    $this->diffwus = 0;
		} else {
		    $this->diffwus = $this->wu_count - $wucountYesterday;
		}
		$this->diffstats = true;
	    }
	}
	

	function getDiffWUCount() {
	    $this->calcDiffStats();
	    return $this->diffwus;
	}
	
	
	function getWuPerDay() {
	    $user = $this->getUser();
	    $wu_per_day = $this->getWUCount() / ($user->getRegistrationTime() / 86400);
	}
	
	
	
	function getCpuTime() {
	    return $this->wu_count * $this->averagetime;
	}
	
	function getEMail() {
	    return $this->email;
	}
	
	function getWUCount() {
	    return $this->wu_count;
	}
	
	function getAverageTime() {
	    return $this->averagetime;
	}
	
	function getPercentage() {
	    return $this->percentage;
	}
	
	function getRank() {
	    return $this->rank;
	}
	
	function isValid() {
	    return ($this->status == 0);
	}
	
	function getStatus() {
	    return $this->status;
	}
	
	function getVersion() {
	    return $this->version;
	}
	
	function getComponentID() {
	    return $this->componentID;
	}
	
	function getUser() {
	    return $this->user;
	}
	
	function insert()
        {
	    ## mal sehen, ob in den letzten 20 sek schon ein Eintrag existiert
	    $query = "SELECT ID FROM " . $GLOBALS["table_userstats"] . " WHERE (user_ID=" . $this->user->getID() . ") AND (timestamp>=" . (time()-20) . ") LIMIT 0,1";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_STATS;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Insert(1)";
		RETURN_FALSE;
	    } else {
		if(mysql_num_rows($result)>0) {
		    $row = mysql_fetch_row($result);
		    return $row[0];
		}
	    }

	    $query = "INSERT INTO " . $GLOBALS["table_userstats"] . " (user_ID, wu_count, averagetime_x10, rank, percentage_x10k, timestamp) VALUES(" . $this->user->getID() . ", " . $this->getWUCount() . ", " . ($this->getAveragetime() * 10) . ", " . $this->getRank() . ", " . (($this->getPercentage()) *10000) . ", " . time() . ")";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_INSERT_STATS2;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Insert(2)";
		return false;
	    } else {
		return mysql_insert_id();
	    }
	    
	    
	    $this->status = $this->ERR_INSERT_STATS2;
	    $this->mysql_errno = mysql_errno();
	    $this->mysql_error = mysql_error();
	    $this->errorline   = "Insert(3)";
	    RETURN_FALSE;
	}
	
	
	function fetchStatsFromCache() {
	    $query = "SELECT wu_count, averagetime_x10, rank, percentage_x10k FROM " . $GLOBALS["table_userstats"] . " WHERE user_ID=" . $this->user->getID() . " AND timestamp>=" . (time() - $GLOBALS["cachetime_user"]) . " LIMIT 0,1";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_STATS;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Cache(1)";
	    } else {
		if(mysql_num_rows($result) != 0) {
		    ## user stats
		    $row = mysql_fetch_array($result);
		    $this->wu_count = $row["wu_count"];
		    $this->averagetime = $row["averagetime_x10"] / 10; # data is stored with a multiplikator of 10
		    $this->rank = $row["rank"];
		    $this->percentage = $row["percentage_x10k"] / 10000; # data is stored with a multiplicator of 10000
		    $this->cachehit = true;
		    $this->cachedStats = 1;
		    return true;
		}
	    }
	    return false;
	}
	
	
	function fetchStatsFromServer() {

	    # close the db connection and free resources ...
	    # this is done because of the excessive load of the counter server
	    mysql_close($this->conn_id);

	    

	    $user = $this->getUser();
	    
	    // we need the xml parser
	    require_once("./php/kxparse.php");
	    
	    //load the file into the parser: constructor(string file)
	    $xml_userdata=new kxparse("http://" . $GLOBALS["server1"] . "/fcgi-bin/fcgi?email=" . $user->getMail() . "&cmd=user_xml");
	    
	    if(strlen($xml_userdata->xml) == 0) {
		$xml_userdata=new kxparse("http://" . $GLOBALS["server2"] . "/cgi-bin/cgi?email=" . $user->getMail() . "&cmd=user_xml");
	    }
	    
	    
	    # reconnect to database
	    $this->conn_id = @mysql_connect($GLOBALS["db_server"],$GLOBALS["db_user"],$GLOBALS["db_password"]);
	    if (!$this->conn_id) {
		$this->status = $this->ERR_DB_CONNECT;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "Server(4)";
		RETURN_FALSE;
	    }
	    
	    if(strlen($xml_userdata->xml) == 0) {
		$this->status = $this->ERR_READ_SERVER;
		$this->errorline   = "Server(1)";
		return false;
	    } else {
		if($xml_userdata->count_tag("userstats:userinfo", "1:?") == 1) {
		    $name = $xml_userdata->get_tag_text("userstats:userinfo:name","1:1:1");
		    $this->wu_count = $xml_userdata->get_tag_text("userstats:userinfo:numresults","1:1:1");
		    $average_str = $xml_userdata->get_tag_text("userstats:userinfo:avecpu","1:1:1");
		    # echo "Last result: " . $xml_userdata->get_tag_text("userstats:userinfo:lastresulttime","1:1:1") . "<br/>\n";
		    $grab = eregi("([a-zA-Z]+) ([a-zA-Z]+) +([0-9]+) +([0-9]+):([0-9]+):([0-9]+) ([0-9]+)", $xml_userdata->get_tag_text("userstats:userinfo:regdate","1:1:1"), $reg_str); # Registrierung
		    $teamname = $xml_userdata->get_tag_text("userstats:groupinfo:group","1:1:1");
		    $this->rank = $xml_userdata->get_tag_text("userstats:rankinfo:rank","1:1:1");
		    $this->percentage = 100 - $xml_userdata->get_tag_text("userstats:rankinfo:top_rankpct","1:1:1");
		    # $xml_userdata->get_tag_text("userstats:userinfo:usertime","1:1:1")
		    # echo "Total users: " . $xml_userdata->get_tag_text("userstats:rankinfo:ranktotalusers","1:1:1") . "<br/>\n";
	    
	    
		    ## Daten verarbeiten
		    $month = array("Jan" => "1", "Feb" => "2", "Mar" => "3", "Apr" => "4", "May" => "5", "Jun" => "6", "Jul" => "7", "Aug" => "8", "Sep" => "9", "Oct" => "10", "Nov" => "11", "Dec" => "12");
		    $reg = mktime($reg_str[4], $reg_str[5], $reg_str[6], $month[$reg_str[2]], $reg_str[3], $reg_str[7]);
	    
		    if (!strpos($average_str, "years")) {
			$average_pos = explode(",", str_replace(" hr",",", str_replace(" min",",", str_replace(" sec","", $average_str))));
			$this->averagetime = ($average_pos[0]*3600) + ($average_pos[1]*60) + $average_pos[2];
		    } else {
			## eigendlich stimmt diese Rechnung nicht ganz (Schaltjahre), aber Seti rechnet leider auch so
			$this->averagetime = (str_replace(" years","", $average_str)*365*24*60*60);
		    }
		    $cputime = $this->averagetime * $this->wu_count;
	    
     
    		    # store data of user
	    	    if(!$user->update($name, $teamname, $reg)) {
			$this->status      = $this->ERR_UPDATE_USER;
			$this->errorline   = "Server(2)";
			return false;
		    }
		
		    # store new retrieved statistics
		    return $this->insert();
		} else {
		    $this->status = $this->ERR_NONEXISTING_USER;
		    $this->errorline   = "Server(3)";
		    return false;
		}
	    }
	    return false;
	}
	
	
	function UserStats($id) {
	    $old_abort = ignore_user_abort(1);
	    $this->conn_id = @mysql_connect($GLOBALS["db_server"],$GLOBALS["db_user"],$GLOBALS["db_password"]);
	    if (!$this->conn_id) {
		$this->status = $this->ERR_DB_CONNECT;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "init(1)";
	    } else {
		$this->user = new UserData($id, $this->conn_id);
		
		if($this->user->isValid()) {
		    $readCache = false;
		    $readServer = false;
		    $lockingtries = 13;
		    while(!($readCache || $readServer ) && $this->isValid()) {
			$readCache = $this->fetchStatsFromCache();
			if($this->isValid() && (!$readCache)) {
			    ## check of database was not successful, no suitable data
			    ## the counter must fetch fresh data from Berkeley
			    
			    # lock the table, because we want to make shure, that only one client 
			    # fetches the data for one user at a time
			    $this->getTableLock();
			    
			    # lock if there is another thread fetching the data already
			    if($this->isValid() && $this->isEntryLocked()) {
				$this->releaseTableLock();
				sleep(1);
				# we must wait until the other thread is ready
				while(($this->isEntryLocked()) && ($lockingtries != 0)) {
				    $lockingtries--;
				    # close the db connection and free resources ...
				    # this is done because of the excessive load of the counter server
				    mysql_close($conn_id);
				    sleep(2);
				    $conn_id = @mysql_connect($GLOBALS["db_server"],$GLOBALS["db_user"],$GLOBALS["db_password"]);
				    if (!$conn_id) {
					$this->status = $this->ERR_DB_CONNECT;
					$this->mysql_errno = mysql_errno();
					$this->mysql_error = mysql_error();
					$this->errorline   = "init(2)";
					break;
				    }
				}
				# we don't want to rotate for ever ;)
				if($lockingtries == 0) {
				    $this->status = $this->ERR_READ_SERVER;
				    $this->errorline   = "init(3)";
				}
			    } else if($this->isValid()) {
				# we will fetch the data
				$readServer = true;
				$this->getEntryLock();
				$this->releaseTableLock();
				
				$this->fetchStatsFromServer();
				
				# $this->getTableLock();
				$this->releaseEntryLock();
				# $this->releaseTableLock();
			    } else {
				# in case of error release the lock on the table
				$this->releaseTableLock();
			    }
			}
		    }
		} else {
		    $this->status = $this->ERR_NO_USER;
		    $this->errorline   = "init(2)";
		}
	    }
	    $this->cleanupDB();
	    ignore_user_abort($old_abort);
	}
	
	
	#
	# Locking of the table $table_lock
	#
	function getTableLock()
	{
	    $ret_val = false;
	    $query = "LOCK TABLES " . $GLOBALS["table_lock"] . " WRITE";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_SET_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "GetTableLock()";
	    } else {
		$ret_val = true;
	    }
	    return $ret_val;
	}
	
	
	#
	# Lock a special user, so that another thread can't update the 
	# stats from the server
	# interprocess locking and syncronisation
	#
	function getEntryLock()
	{
	    $ret_val = false;
	    $user = $this->getUser();
	    $this->lock_timestamp = time();
	    $query = "INSERT INTO " . $GLOBALS["table_lock"] . " (type, c_ID, timestamp) VALUES(" . $this->componentID . ", " . $user->getID() . ", " . $this->lock_timestamp . ")";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_WRITE_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "GetEntryLock()";
		$this->lock_timestamp = 0;
	    } else {
		$ret_val = true;
	    }
	    return $ret_val;
	}
	
	
	#
	# unlock the table $table_lock
	#
	function releaseTableLock()
	{
	    $ret_val = false;
	    $query = "UNLOCK TABLES";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_REM_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "ReleaseTableLock()";
	    } else {
		$ret_val = true;
	    }
	    return $ret_val;
	}
	
	
	#
	# remove the lock of the actual user id, so that other threads 
	# can try to reread the cache or update the stats
	# interprocess locking and syncronisation
	#
	function releaseEntryLock()
	{
	    $ret_val = false;
	    $user = $this->getUser();
	    $query = "DELETE FROM " . $GLOBALS["table_lock"] . " WHERE type=" . $this->componentID . " AND c_ID=" . $user->getID() . " AND timestamp=" . $this->lock_timestamp;
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_DELETE_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "ReleaseEntryLock()";
	    } else {
		$ret_val = true;
		$this->lock_timestamp = 0;
	    }
	    return $ret_val;
	}
	
	
	#
	# if there is a entry with the actual user id in the lock-table this function returns true
	# this function can be used to let the actual thread wait for "realeaseEntryLock() of 
	# another thread with the same user id
	# if the other lock is older than 180 seconds it is removed, because no PHP thread should run such long
	# interprocess locking and syncronisation
	#
	function isEntryLocked()
	{
	    $ret_val = false;
	    $user = $this->getUser();
	    $query = "SELECT MAX(timestamp) FROM " . $GLOBALS["table_lock"] . " WHERE type=" . $this->componentID . " AND c_ID=" . $user->getID();
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_LOCK;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "IsEntryLocked(1)";
	    } else {
		while($row = mysql_fetch_array($result)) {
		    if($row[0] > 0) {
			if($row[0] < (time() - 20)) {
			    # possible a dead lock
			    # we remove this to leave the counter alive
			    $query = "DELETE FROM " . $GLOBALS["table_lock"] . " WHERE type=" . $this->componentID . " AND c_ID=" . $user->getID();
			    $delete = mysql_db_query($GLOBALS["db"], $query);
			    if(!$result) {
				$this->status = $this->ERR_REM_DB_LOCK;
				$this->mysql_errno = mysql_errno();
				$this->mysql_error = mysql_error();
				$this->errorline   = "IsEntryLocked(2)";
			    }
			} else {
			    $ret_val = true;
			}
		    }
		}
	    }
	    return $ret_val;
	}
	
	
	function cleanupDB()
	{
	    ## alles lschen was lter als 16 Tage ist
	    $query = "DELETE FROM " . $GLOBALS["table_userstats"] . " WHERE timestamp<" . (time()-1382400);
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
	    } else {
	        return true;
	    }
	    return false;
	}
	
	
	function getDiff14days() {
	    $lasttwoweeks = mktime(0,0,0, date("m"), date("d")-14, date("Y"));
	    $retval = array();
	    $retval["count"] = 0;
	    $retval["duration"] = time() - $lasttwoweeks;
	    $user=$this->getUser();
	    

	    $query = "SELECT wu_count, timestamp FROM " . $GLOBALS["table_userstats"] . " WHERE user_ID=" . $user->getID() . " AND timestamp>=" . ($lasttwoweeks) . " ORDER BY timestamp LIMIT 0,1";
	    $result = mysql_db_query($GLOBALS["db"], $query);
	    if(!$result) {
		$this->status = $this->ERR_READ_DB_STATS;
		$this->mysql_errno = mysql_errno();
		$this->mysql_error = mysql_error();
		$this->errorline   = "14days(1)";
	    } else {
		if(mysql_num_rows($result)>0) {
		    $row = mysql_fetch_row($result);
		    $retval["count"] = $this->getWUCount() - $row[0];
		    $retval["duration"] = time() - $row[1];
		}
	    }
	    
	    return $retval;
	}
	
	
	function getLockTimestamp()
	{
	    return $this->lock_timestamp;
	}
    
    
    }
    
  }
    
?>