<?php
    require("php/prepend.php");
    $lastactivedate = mktime(0,0,0,date("m"), date("d")-$GLOBALS["activedays"], date("Y"));
    
    
    function size_format($bytes)
    {
	$units = array("&nbsp;B", "kB", "MB", "GB");
	$n = 0;
	while($bytes>=1024) {
	    $n++;
	    $bytes=$bytes/1024;
	}
	return number_format($bytes, 2, ",", ".") . " " . $units[$n];
    }
    
?>
<html>
 <head>
  <title>
   SetiStats
  </title>
  <link href="style.css" rel="stylesheet" type="text/css" />
  
 </head>

 <body>
  <a name="top"></a>
  <!-- body table -->
  <table align="center" valign="top" border="0" cellpadding="8" cellspacing="0" width="85%">
   <!-- top header -->
   <tr>
    <td valign="center" width="25%" colspan="2">
    <?php
        @include("header.inc.php");
    ?>
    </td>
   </tr>
   <!-- end top header -->
 
   <tr>
    <!-- left column -->
    <td valign="top" width="25%">
     <?php
        require("navigation.inc.php");
     ?>
     <br />
     
     <!-- sidebox -->
     <table bgcolor="#000000" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td>
        <table border="0" cellpadding="3" cellspacing="1" width="100%">
         <tr>
          <td bgcolor="#cccccc" nowrap="">
           &nbsp;<a class="title" href="statistics.php#top">Page Index</a>
          </td>
         </tr>
         <tr>
          <td bgcolor="#ffffff" nowrap="">
	   &nbsp;<span class="small">o</span>
           <a class="nav" href="statistics.php?r=1">Zugriffe</a>&nbsp;
           <br />
	   &nbsp;<span class="small">o</span>
           <a class="nav" href="statistics.php?r=2">Counter</a>&nbsp;
           <br />
           &nbsp;<span class="small">o</span>
           <a class="nav" href="statistics.php?r=3">Webseiten</a>&nbsp;
           <br />
           &nbsp;<span class="small">o</span>
           <a class="nav" href="statistics.php?r=5">Registrierungen</a>&nbsp;
	   <br />
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
     <!-- end sidebox -->
    </td>
    <!-- end left column -->

    <!-- right column -->
    <td valign="top" width="75%">
     <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td valign="top" width="100%">


        <!-- story -->
        <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
         <tr>
          <td>
           <table border="0" cellpadding="8" cellspacing="1" width="100%">
            <tr>
             <td bgcolor="#ffffff">
              <h2>
               <?php
	        if($r==2) {
		    echo "Statistiken um die Counter";
		} else if($r==3) {
		    echo "Statistiken um die Webseiten";
		} else if($r==4) {
		    echo "Statistiken um Seti@Home";
		} else if($r==5) {
		    echo "Statistiken um die Registrierungen";
		} else {
		    echo "Statistiken";
		    $r = 1;
		}
	       
	       ?>
              </h2>
	      
	      <p>
	       [ <a href="?r=1">Gesamt</a> ] [ <a href="?r=2">Counter</a> ] [ <a href="?r=3">Webseiten</a> ] [ <a href="?r=5">Registrierungen</a> ]
	      </p>
	      
	      
	    	    <?php
			if(($r == 2) || ($r == 3)) {
				$usercount = array();
				$firstuserhit = 9999999999;
				$teamcount = array();
				$firstteamhit = 9999999999;
				$pagecount = 0;
				$firstpagehit = 9999999999;
				
				# Get hits from table 'hit_summary'
				$query = " SELECT SUM(count) as count, type, cached, IF((entryID>0 AND type<3), 1, 0) AS success, MIN(firstaccess) AS firstaccess FROM " . $GLOBALS["table_hitsummary"] . "  GROUP BY type, cached, success";
				$result = mysql_db_query($GLOBALS["db"], $query);
				if(!$result) {
				    echo "<color=red>Fehler</color><br/><b>Query:</b> $query<br/>MySQL: " . mysql_error() . "<br/>\n";
				} else {
				    while($row = mysql_fetch_array($result)) {
					if($row["type"] == 1) {
					    if($row["success"] == 1) {
						$usercount[$row["cached"]] = $row["count"];
					    } else {
						$usercount[2] = $row["count"];
					    }
					    $firstuserhit = min($firstuserhit, $row["firstaccess"]);
					} else if($row["type"] == 2) {
					    if($row["success"] == 1) {
						$teamcount[$row["cached"]] = $row["count"];
					    } else {
						$teamcount[2] = $row["count"];
					    }
					    $firstteamhit = min($firstteamhit, $row["firstaccess"]);
					} else if($row["type"] == 3) {
					    $pagecount += $row["count"];
					    $firstpagehit = $row["firstaccess"];
					}
				    }
				}
				
				
				# Get hits from table 'hits'
				$query = " SELECT COUNT(*) as count, type, cached, IF((entryID>0 AND type<3), 1, 0) AS success, MIN(timestamp) AS firstaccess FROM " . $GLOBALS["table_hits"] . "  GROUP BY type, cached, success";
				# WHERE type=1 AND timestamp >= " . $lastactivedate
				$result = mysql_db_query($GLOBALS["db"], $query);
				if(!$result) {
				    echo "<color=red>Fehler</color><br/><b>Query:</b> $query<br/>MySQL: " . mysql_error() . "<br/>\n";
				} else {
				    while($row = mysql_fetch_array($result)) {
					if($row["type"] == 1) {
					    if($row["success"] == 1) {
						$usercount[$row["cached"]] += $row["count"];
					    } else {
						$usercount[2] += $row["count"];
					    }
					    $firstuserhit = min($firstuserhit, $row["firstaccess"]);
					} else if($row["type"] == 2) {
					    if($row["success"] == 1) {
						$teamcount[$row["cached"]] += $row["count"];
					    } else {
						$teamcount[2] += $row["count"];
					    }
					    $firstteamhit = min($firstteamhit, $row["firstaccess"]);
					} else if($row["type"] == 3) {
					    $pagecount += $row["count"];
					    $firstpagehit = min($firstpagehit, $row["firstaccess"]);
					}
				    }
				}
				
				$gesamtzugriffe = $usercount[0] + $usercount[1] + $usercount[2] + $teamcount[0] + $teamcount[1] + $teamcount[2];
				$cacheratio = ($usercount[1] + $teamcount[1]) * 100 / $gesamtzugriffe;
				$errorratio = ($usercount[2] + $teamcount[2]) * 100 / $gesamtzugriffe;
			    }
			?>
	      
	      
	      <?php
	        if($r == 2) {
	      ?>
	        
	      <p>
	        Hier folgen ein paar Statistiken &uuml;ber die Verwendung der Counter. Durch diese Auswertung kann man leichter absch&auml;tzen, wie sich die Nutzung in Zukunft entwickeln wird. Dies ist notwendig, um unerwarteten Kosten durch zu hohen Traffic entgegenzuwirken. Sollte also absehbar sein, da&szlig; die Anzahl der Counterabrufe in naher Zukunft an ein Limit st&auml;&szlig;t, so kann man die Registrierung neuer User und Teams unterbinden. Dadurch wird einer weiteren Zunahme der Abrufe entgegengewirkt.
	      </p>
	      
	      <p>
	        Die Zugriffe in den letzten 24 Stunden verteilten sich so:<br/>
		<img width="600" height="300" src="graphc24.php" alt="Grafik: Zugriffe der letzten 24 Stunden">
	      </p>
	      
	      <p>
	        In den letzten 31 Tagen erfolgte die Nutzung der Counter so:<br/>
		<img width="600" height="300" src="graphc31.php" alt="Grafik: Zugriffe der letzten 31 Tage">
	      </p>
	      
	      <p>	    
		Insgesamt wurde auf die Counter <?php echo number_format($gesamtzugriffe, 0, ",", "."); ?> mal zugegriffen. Diese Zugriffe verteilen sich wie folgt:
	      </p>
	      
	        <table width="50%" align="center">
	        <tr>
		    <td class="normal">
			&nbsp;
		    </td>
		    <td class="normal" align="right">
			 <b>Benutzer</b>
		    </td>
		    <td class="normal" align="right">
			 <b>Teams</b>
		    </td>
		</tr>
		
		
		<tr>
		    <td class="normal" class="normal">
			 <b>Gesamt</b>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format($usercount[0] + $usercount[1] + $usercount[2], 0, ",", ".") . "\n";
			    ?>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format($teamcount[0] + $teamcount[1] + $teamcount[2], 0, ",", ".") . "\n";
			    ?>
		    </td>
		</tr>
		<tr>
		    <td class="normal">
			 <b>davon gecached</b>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format($usercount[1], 0, ",", ".") . "\n";
			    ?>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format($teamcount[1], 0, ",", ".") . "\n";
			    ?>
		    </td>
		</tr>
		<tr>
		    <td class="normal">
			 <b>davon fehlerhaft</b>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format(0 + $usercount[2], 0, ",", ".") . "\n";
			    ?>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format(0 + $teamcount[2], 0, ",", ".") . "\n";
			    ?>
		    </td>
		</tr>
	      </table>
	      
	      
	      <p>
	        Die Effizienz des Caches liegt bei <?php echo number_format(0 + $cacheratio, 2, ",", "."); ?>% &uuml;ber alle Zugriffe. Die Fehlerquote liegt dabei bei <?php if($errorratio < 0.15) { echo "nur "; } echo number_format(0 + $errorratio, 2, ",", "."); ?>%. Mit fehlerhaft ist hierbei jeder Counter-Abruf gemeint, der kein einwandfreies Resultat bringt, wie "keine Verbindung zum Server" oder interne Fehler...
	      </p>
	      
	      
	      <?php
	        } else if($r == 3) {
	      ?>
	        
	      <p>
	        Die Zugriffe auf die Webseiten produzieren verhltnismssig wenig Traffic. Aber denoch kann es ja intressant sein, zu sehen, wie viele Abrufe es sind.
	      </p>
	      
	      <p>
	        Die Zugriffe in den letzten 24 Stunden verteilten sich so:<br/>
		<img width="600" height="300" src="graphw24.php" alt="Grafik: Zugriffe der letzten 24 Stunden">
	      </p>
	      
	      <p>
	        In den letzten 31 Tagen ging es so ab:<br/>
		<img width="600" height="300" src="graphw31.php" alt="Grafik: Zugriffe der letzten 31 Tage">
	      </p>
	      
	      <p>
		<?php
		    setlocale("LC_ALL", "de_DE");
		?>
	        Seit <b><?php echo strftime("%A, dem %x", $firstpagehit); ?></b> wurde auf diese Webseiten <b><?php echo number_format($pagecount, 0, ",", "."); ?></b> mal zugegriffen.
	      </p>
	      
	      <?php
	        } else if($r == 5) {
	      ?>
	        
	      <p>
	        Auf dieser Seite kann man sehen, von wie vielen Teams oder einzelnen Usern die Counter genutzt werden. Genauer gesagt, sieht man, wieviele Registrierungen f&uuml;r die Teams und User vorliegen und wie viele davon noch genutzt werden.
	      </p>
	      
	      <p>
	       Der folgenden Tabelle kannst Du entnehmen, wie viele Benutzer und Teams f&uuml;r die Counter auf diesem Server registriert sind. Au&szlig;erdem wird ermittelt, welche Registrierungen noch aktiv genutzt werden. Hierbei wird der Zeitraum der letzten <?php echo $activedays; ?> Tage zugrunde gelegt.
	      </p>
	      
	      <table width="50%" align="center">
	        <tr>
		    <td>
			&nbsp;
		    </td>
		    <td class="normal" align="right">
			 <b>Benutzer</b>
		    </td>
		    <td class="normal" align="right">
			 <b>Teams</b>
		    </td>
		</tr>
		<tr>
		    <td class="normal">
			 <b>Registriert</b>
		    </td>
		    <td class="normal" align="right">
			    <?php
				$query = "SELECT COUNT(*) FROM " . $GLOBALS["table_users"];
				# WHERE type=1 AND timestamp >= " . $lastactivedate
				$result = mysql_db_query($GLOBALS["db"], $query);
				if(!$result) {
				    echo "<color=red>Fehler</color>\n";
				} else {
				    $row = mysql_fetch_row($result);
				    echo number_format($row[0], 0, ",", ".") . "\n";
				}
			    ?>
		    </td>
		    <td class="normal" align="right">
			    <?php
				$query = "SELECT COUNT(*) FROM " . $GLOBALS["table_teams"];
				# WHERE type=1 AND timestamp >= " . $lastactivedate
				$result = mysql_db_query($GLOBALS["db"], $query);
				if(!$result) {
				    echo "<color=red>Fehler</color>\n";
				} else {
				    $row = mysql_fetch_row($result);
				    echo number_format($row[0], 0, ",", ".") . "\n";
				}
			    ?>
		    </td>
		</tr>
		<tr>
		    <td class="normal">
			 <b>Aktiv</b>
		    </td>
		    <td class="normal" align="right">
			    <?php
				$activeusers = 0;
				$activeteams = 0;
				$query = "SELECT type FROM " . $GLOBALS["table_hits"] . " WHERE entryID<>0 AND timestamp>=$lastactivedate GROUP BY type, ABS(entryID)";
				$result = mysql_db_query($GLOBALS["db"], $query);
				if(!$result) {
				    echo "<color=red>" . mysql_error() . "</color>\n";
				} else {
				    while($row = mysql_fetch_array($result)) {
					if($row["type"] == 1) {
					    $activeusers++;
					} else if($row["type"] == 2) {
					    $activeteams++;
					}
					
				    }
				}
				
				echo number_format($activeusers, 0, ",", ".") . "\n";
			    ?>
		    </td>
		    <td class="normal" align="right">
			    <?php
				echo number_format($activeteams, 0, ",", ".") . "\n";
			    ?>
		    </td>
		</tr>
	      </table>
	      
	      <p>
	        Grafisch sieht das bei den Usern im letzten Monat so aus:<br/>
		<img width="600" height="300" src="graphu31.php" alt="Grafik: User in den letzten 31 Tagen">
	      </p>
	      
	      <p>
	        Ein Blick auf die Nutzung bei den Teams offenbart folgendes Bild:<br/>
		<img width="600" height="300" src="grapht31.php" alt="Grafik: Teams in den letzten 31 Tagen">
	      </p>
	      
	      <p>
	      </p>


	      <?php
	        } else {
	      ?>



              <p>
	       Wenn man so etwas wie einen Counter betreibt, dann intressiert man sich auch daf&uuml;r, wie dieser genutzt wird. Ich erfasse nun seit ein paar Wochen die Zugriffe auf die Counter, um daran auswerten zu knnen, wie stark die jeweiligen Counter frequentiert werden um eine Prognose fr die Zukunft zu ermglichen. Bei der Erfassung wird auch festgehalten, ob fr die Ausgabe des jeweiligen Counters ein Zugriff auf den Server von <a target="_blank" href="redirect.php?url=www.setiathome.com">Seti@Home</a> notwendig war oder die Anfrage gecached wurde. Das Ganze erfolgt nat&uuml;rlich anonymisiert (es wird also keine IP erfa&szlig;t).
              </p>

              <p>
	       Auf diesen Seiten werde ich nun die erfa&szlig;ten Daten aufbereiten.
              </p>
	      
	      <p>
		Gesamtzugriffe auf diese Website:<br/>
		<img width="600" height="300" src="graph31.php" alt="Grafik: Zugriffe in den letzten 31 Tagen">
	      </p>
	      
	      <?php
	        }
	      ?>
	      
             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
        <!-- end story -->
	
	<?php
	    if($r == 1) {
	?>    
	
	<br/>
	
	<!-- story -->
	    <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
		<tr>
		    <td>
			<table border="0" cellpadding="8" cellspacing="1" width="100%">
			    <tr>
				<td bgcolor="#ffffff">
				    <h2>Datenbank Informationen</h2>


				    <table width="100%">
					<tr>
					    <td class="normal" align="left"><b>Tabelle f&uuml;r</b></td>
					    <td class="normal" align="right"><b>Zeilen</b></td>
					    <td class="normal" align="right"><b>Daten</b></td>
					    <td class="normal" align="right"><b>Index-Gr&ouml;sse</b></td>
					    <td class="normal" align="right"><b>Gesamt</b></td>
					</tr>
				    
	
<?php

				    $db_size = 0;
				    $query = "SHOW TABLE STATUS";
				    $result = mysql_db_query($GLOBALS["db"], $query);
				    if(!$result) {
				    
				    } else {
					while($row=mysql_fetch_array($result)) {
					    $tbl_name = $row["Name"];
					    if(($tbl_name == $GLOBALS["table_hits"])) {
						echo "<tr><td style=\"font-size:80%;\">Zugriffe</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_hitsummary"])) {
						echo "<tr><td style=\"font-size:80%;\">Zugriffs-Zusammenfassung</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_users"])) {
						echo "<tr><td style=\"font-size:80%;\">Benutzer</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_teams"])) {
						echo "<tr><td style=\"font-size:80%;\">Gruppen</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_userstats"])) {
						echo "<tr><td style=\"font-size:80%;\">Benutzerdaten</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_teamstats"])) {
						echo "<tr><td style=\"font-size:80%;\">Gruppendaten</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_lock"])) {
						echo "<tr><td style=\"font-size:80%;\">Interthread-Locks</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    }
					}
				    }

?>
					<tr>
					    <td class="normal" align="left" colspan="5"><hr size="1"/></td>
					</tr>
					<tr>
					    <td class="normal" align="left" colspan="4"><b>Gesamt</b>:</td>
					    <td class="normal" align="right"><?php echo size_format($db_size); ?></td>
					<tr>
				    </table>
	
	
<?php


    # DB cleanup
    $query = "LOCK TABLES " . $GLOBALS["table_hitsummary"] . " WRITE, " . $GLOBALS["table_hits"] . " WRITE";
    $result = mysql_db_query($GLOBALS["db"], $query);
    if(!$result) {
        echo "<p><b>Error!</b><br/>LOCK TABLE not successful!<br/>MySQL reports: " . mysql_error() . "<br/></p>";
    } else {
    
	$point_of_death = mktime(0,0,0,date("m"), date("d")-40, date("Y"));
	
	$summary_error = false;
	
	$delete_query = "DELETE FROM " . $GLOBALS["table_hits"] . " WHERE timestamp< " . $point_of_death . " AND (0";
    
	$query = "SELECT COUNT(*) AS count, type, entryID, cached, MIN(timestamp) as firstaccess FROM " . $GLOBALS["table_hits"] . " WHERE timestamp<" . $point_of_death . " GROUP BY type, entryID, cached";
	
	$result = mysql_db_query($GLOBALS["db"], $query);
	if(!$result) {
	    echo "<p><b>Error!</b><br/>SELECT not successful!<br/>MySQL reports: " . mysql_error() . "<br/></p>";
	} else {
	    while($row = mysql_fetch_array($result)) {
		$query = "UPDATE " . $GLOBALS["table_hitsummary"] . " SET count=count+" . $row["count"] . " WHERE entryID=" . $row["entryID"] . " AND cached=" . $row["cached"] . " AND type=" . $row["type"];
		$q_update = mysql_db_query($GLOBALS["db"], $query);
		if(!$q_update) {
		    echo "<p><b>Error!</b><br/>UPDATE not correct implemented<br/>MySQL reports: " . mysql_error() . "<br/></p>";
		} else {
		    if(mysql_affected_rows()==0) {
			$query = "INSERT INTO " . $GLOBALS["table_hitsummary"] . " (type, entryID, cached, count, firstaccess) VALUES(" . $row["type"] . ", " . $row["entryID"] . ", " . $row["cached"] . ", " . $row["count"] . ", " . $row["firstaccess"] . ")";
			$insert = mysql_db_query($GLOBALS["db"], $query);
			if(!$insert) {
			    echo "<p><b>Error!</b><br/>INSERT not correct implemented<br/>MySQL reports: " . mysql_error() . "<br/></p>";
			    $summary_error = true;
			} else {
			    # INSERT successful
			    $delete_query .= " OR (type=" . $row["type"] . " AND entryID=" . $row["entryID"] . " AND cached=" . $row["cached"] . ")";
			}
		    } else {
			# UPDATE successful
			$delete_query .= " OR (type=" . $row["type"] . " AND entryID=" . $row["entryID"] . " AND cached=" . $row["cached"] . ")";
		    }
		}
	    }
	}
	
	$delete_query .= ")";
	
	if(!summary_error) {
	    # no error occured, we can delete all the entry before our point of dearh...
	    $delete_query = "DELETE FROM " . $GLOBALS["table_hits"] . " WHERE timestamp<" . $point_of_death;
	}
	
	$delete = mysql_db_query($GLOBALS["db"], $delete_query);
	if(!$delete) {
	    echo "<p><b>Error!</b><br/>DELETE not correct implemented<br/>MySQL reports: " . mysql_error() . "<br/></p>";
	} else {
	    $deleted_rows = mysql_affected_rows();
	}
	
	
	$query = "UNLOCK TABLES";
	$result = mysql_db_query($GLOBALS["db"], $query);
	if(!$result) {
	    echo "<p><b>Error!</b><br/>UNLOCK TABLES not successful!<br/>MySQL reports: " . mysql_error() . "<br/></p>";
	    
	}
	
    }



    if($deleted_rows > 0) {
	$optimize = mysql_db_query($GLOBALS["db"], "OPTIMIZE TABLE " . $GLOBALS["table_hits"] . ", " . $GLOBALS["table_hitsummary"] . ", " . $GLOBALS["table_users"] . ", " . $GLOBALS["table_userstats"] . ", " . $GLOBALS["table_teams"] . ", " . $GLOBALS["table_teamstats"] . ", " . $GLOBALS["table_lock"]);
	if(!$optimize) {
	    echo "<p><b>Fehler!</b><br/>OPTIMIZE TABLE not correct implemented<br/>MySQL reports: " . mysql_error() . "<br/></p>";
	}
?>
			    <h2>Datenbank-Bereinigung</h2>
<?php
	echo "<p>Es wurden " . number_format($deleted_rows, 0, ",", ".") . " Zeilen aus der Datenbank entfernt und f&uuml;r weitere statistische Auswertungen zusammengefa&szlig;t. Anschliessend wurde die Datenbank komprimiert.</p>\n";
?>



				    <table width="100%">
					<tr>
					    <td class="normal" align="left"><b>Tabelle f&uuml;r</b></td>
					    <td class="normal" align="right"><b>Zeilen</b></td>
					    <td class="normal" align="right"><b>Daten</b></td>
					    <td class="normal" align="right"><b>Index-Gr&ouml;sse</b></td>
					    <td class="normal" align="right"><b>Gesamt</b></td>
					</tr>
				    
	
<?php

				    $db_size = 0;
				    $query = "SHOW TABLE STATUS";
				    $result = mysql_db_query($GLOBALS["db"], $query);
				    if(!$result) {
				    
				    } else {
					while($row=mysql_fetch_array($result)) {
					    $tbl_name = $row["Name"];
					    if(($tbl_name == $GLOBALS["table_hits"])) {
						echo "<tr><td style=\"font-size:80%;\">Zugriffe</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_hitsummary"])) {
						echo "<tr><td style=\"font-size:80%;\">Zugriffs-Zusammenfassung</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_users"])) {
						echo "<tr><td style=\"font-size:80%;\">Benutzer</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_teams"])) {
						echo "<tr><td style=\"font-size:80%;\">Gruppen</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_userstats"])) {
						echo "<tr><td style=\"font-size:80%;\">Benutzerdaten</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_teamstats"])) {
						echo "<tr><td style=\"font-size:80%;\">Gruppendaten</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    } else if(($tbl_name == $GLOBALS["table_lock"])) {
						echo "<tr><td style=\"font-size:80%;\">Interthread-Locks</td><td align=\"right\" style=\"font-size:80%;\">" . number_format($row["Rows"], 0, ",",".") . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Data_length"]) . "</td><td align=\"right\" style=\"font-size:80%;\">" . size_format($row["Index_length"]) . "</td><td align=\"right\"  style=\"font-size:80%;\">" . size_format($row["Data_length"] + $row["Index_length"]) . "</td></tr>\n";
						$db_size += $row["Data_length"] + $row["Index_length"];
					    }
					}
				    }

?>
					<tr>
					    <td class="normal" align="left" colspan="5"><hr size="1"/></td>
					</tr>
					<tr>
					    <td class="normal" align="left" colspan="4"><b>Gesamt</b>:</td>
					    <td class="normal" align="right"><?php echo size_format($db_size); ?></td>
					<tr>
				    </table>




<?php
    }
?>
				</td>
			    </tr>
			</table>
		    </td>
		</tr>
	    </table>
	    
	    <?php
		}
	    ?>
	    
       </td>
      </tr>
     </table>
    </td>
    <!-- end right column -->
   </tr>
   <?php
    @include("footer.inc.php");
   ?>

  </table>
  <!-- end body table -->
 </body>
</html>
<?php
    require("php/append.php");
?>