<?php
    require("php/prepend.php");
?>
<html>
 <head>
  <title>
   SetiStats - der Team-Counter
  </title>
  <link href="style.css" rel="stylesheet" type="text/css" />
  
 </head>

 <body>
 <a name="top"></a>

  <!-- body table -->
  <table align="center" valign="top" border="0" cellpadding="8" cellspacing="0" width="85%">
   <!-- top header -->
   <tr>
    <td valign="center" width="25%" colspan="2">
    <?php
        @include("header.inc.php");
    ?>
    </td>
   </tr>
   <!-- end top header -->
 
   <tr>
    <!-- left column -->
    <td valign="top" width="25%">
     <?php
        require("navigation.inc.php");
     ?>
     <br />
     
     <!-- sidebox -->
     <table bgcolor="#000000" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td>
        <table border="0" cellpadding="3" cellspacing="1" width="100%">
         <tr>
          <td bgcolor="#cccccc">
          &nbsp;<a class="title" href="user.php#top">Page Index</a> 
          </td>
         </tr>
         <tr>
          <td bgcolor="#ffffff">
           &nbsp;<span class="small">o</span>
           <a class="nav" href="team.php#layouts">Layouts</a>
           <br />
	   &nbsp;<span class="small">o</span>
           <a class="nav" href="team.php#config">Konfiguration</a>
           <br />
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
     <!-- end sidebox -->
     <br/>

     <!-- sidebox -->
     <table bgcolor="#000000" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td>
        <table border="0" cellpadding="3" cellspacing="1" width="100%">
         <tr>
          <td bgcolor="#cccccc">
           &nbsp;<span class="title">Links</span>
          </td>
         </tr>
         <tr>
          <td bgcolor="#ffffff">
           &nbsp;<span class="small">o</span>
           <a class="nav" target="_blank" href="redirect.php?url=www.setiathome.com">Seti@home</a>
           <br />
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
     <!-- end sidebox -->
    </td>
    <!-- end left column -->

    <!-- right column -->
    <td valign="top" width="75%">
     <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td valign="top" width="100%">

        <!-- story -->
        <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
         <tr>
          <td>
           <table border="0" cellpadding="8" cellspacing="1" width="100%">
            <tr>
             <td bgcolor="#ffffff">
              <h2>
              Der Team-Counter.
              </h2>
	      
	      <p>
	       Da bei einem Projekt wie <a target="_blank" href="redirect.php?url=www.setiathome.com">Seti@Home</a> auch schnell die Idee aufkommt, leistungsf&auml;hige Gruppen aufzubauen und so andere Gruppen leistungsm&auml;ssig zu &uuml;bertreffen, gibt es bei <a target="_blank" href="redirect.php?url=www.setiathome.com">Seti@Home</a> auch die sogenannten Teams. F&uuml;r diese mu nat&uuml;rlich auch ein Counter her...
	      </p>
	      
	      <p>
	       Inzwischen gibt es hier bei mir auch schon mehrere verschiedene Layouts, aus denen Du ausw&auml;hlen kannst. Damit Du von den verschiedenen Varianten einen Eindruck bekommst, habe ich Dir hier eine Vorschau eingerichtet. W&auml;hle einfach da f&uuml;r Dich geeignete Layout und gehe dann weiter zur Konfiguration. Dort kannst Du dann Dein Team ausw&auml;hlen oder ein neues Team erstellen und auf die verschiedenen Parameter des Counters Einflu&szlig; nehmen.
	      </p>
	      
	      <a name="layouts"></a>
	      <form action="teamstats_admin.php" method="post">
	      <h3>
	        Die Layouts
	      </h3>
	      <p>
	       Suche Dir hier zuerst ein Layout aus ...
	      </p>
	      <p>
	    	    <table width="100%" border="0" cellpadding="0" cellspacing="0">
			<tr>
			    <td>
				<?php
				    $d = dir("layout/team");
				    while($entry=$d->read())
				    {
					if(is_file("layout/team/" . $entry))
					{
					    $layoutname = substr($entry, 0, strpos($entry, ".php"));
					    # perhaps we need some infos from inside the file
					    # require("layout/user/" . $entry);
					    
					    echo "<input type=\"radio\" name=\"layout\" value=\"$layoutname\"";
					    if($layout==$layoutname) { echo " checked"; }
					    echo "><img src=\"teamstats.php?l=" . $layoutname . "\"><br>
\n&nbsp;<br/>\n";
					}
				    }
				?>
			    </td>
			</tr>
		    </table>
	      </p>
	      
	      <a name="config"></a>
	      <h3>Konfiguration</h3>
	      <p>
	        Dann begebe Dich zur Konfiguration. Dies ist notwendig, da man es wohl niemandem zumuten kann, sich die Parameter f&uuml;r die einzelnen Layouts jedesmal heraus zu suchen oder gar auswendig zu lernen :)
	      </p>
	      <p>
	        <center><input type="submit" value="Konfigurieren &gt;"/></center>
	      </p>
	      <p>
	        Du wirst dort Einstellungen zur Farbgebung oder der Schriftgr&ouml;sse machen k&ouml;nnen, je nachdem, &uuml;ber welche Eigenschaften das jeweilige Layout verf&uuml;gt. Ausserdem kannst Du Dir den Counter auf einer frei w&auml;hlbaren Hintergrundfarbe ansehen, um seine Wirkung zu beurteilen ...
	      </p>
	      
	      </form>

             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
        <!-- end story -->
       </td>
      </tr>
     </table>
    </td>
    <!-- end right column -->
   </tr>
   <?php
    @include("footer.inc.php");
   ?>

  </table>
  <!-- end body table -->
 </body>
</html>
<?php
    require("php/append.php");
?>