<?php
include ("jpgraph/src/jpgraph.php");
include ("jpgraph/src/jpgraph_bar.php");


// Create the graph. These two calls are always required
$graph = new Graph(600, 300, "auto", 10);
$graph->SetScale("textlin");
$graph->SetShadow();
$graph->img->SetMargin(50,20,30,35);
$graph->title->Set("Zugriffe an den letzten 31 Tagen             ");
#$graph->yaxis->title->Set("Zugriffe/Tag");

include("php/initfunctions.php");


for ($i = 0; $i <= 30; $i++) {
    $data1y[] = 0;
}

$data2y = $data1y;
$data3y = $data1y;

$usercount = array();
$teamcount = array();
$query = " SELECT (TO_DAYS(NOW()) - TO_DAYS(FROM_UNIXTIME(timestamp))) AS day, type, COUNT(*) AS count FROM " . $GLOBALS["table_hits"] . " WHERE type<=3 AND timestamp>= " . (mktime(0,0,0,date("m"),date("d")-31,date("Y"))) . " GROUP BY type, day ORDER BY day";
#	echo $query . "<br/>\n";
# WHERE type=1 AND timestamp >= " . $lastactivedate
$result = mysql_db_query($GLOBALS["db"], $query);
if(!$result) {
    echo "<color=red>Fehler: " . mysql_error() . "<br/>\n</color>\n";
} else {
    while($row = mysql_fetch_array($result)) {
	if($row["type"] == 1) {
	    $data1y[31-$row["day"]] += $row["count"];
	} else if($row["type"] == 2) {
	    $data2y[31-$row["day"]] += $row["count"];
	} else if($row["type"] == 3) {
	    $data3y[31-$row["day"]] += $row["count"];
	}
    }
}




// Create the bar plots
$b1plot = new BarPlot($data1y);
$b1plot->SetFillGradient("mediumpurple4","lavender",GRAD_MIDVER);
$b1plot->SetColor("mediumpurple4");
$b1plot->SetFillColor("mediumpurple1");
$b1plot->SetLegend("User");
$b1plot->SetWidth(0.99);


$b2plot = new BarPlot($data2y);
$b2plot->SetFillGradient("mediumred","lightcoral",GRAD_MIDVER);
$b2plot->SetColor("mediumred");
$b2plot->SetFillColor("orangered");
$b2plot->SetLegend("Team");
$b2plot->SetWidth(0.99);

$b3plot = new BarPlot($data3y);
$b3plot->SetFillGradient("yellow4","white",GRAD_MIDVER);
$b3plot->SetColor("yellow4");
$b3plot->SetFillColor("yellow");
$b3plot->SetLegend("Page");
$b3plot->SetWidth(0.99);

// Create the grouped bar plot
$gbplot = new AccBarPlot(array($b3plot,$b2plot, $b1plot));
$gbplot->SetWidth(0.7);

// ...and add it to the graPH
$graph->Add($gbplot);



$graph->title->SetFont(FF_FONT1,FS_BOLD);
$graph->title->Pos(50, 10, "left","top");
$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
$graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

$d = date("d");
$m = date("m");
$y = date("Y");
for($i=31; $i > 0; $i--) {
    $ticks[] = date("j.m.", mktime(0,0,0,$m,($d-$i),$y));
}

$graph->xaxis->SetTickLabels($ticks);
$graph->xaxis->SetTextLabelInterval(3);

$graph->legend->Pos(0.05, 0.01, 'right','top');
$graph->legend->SetLayout(LEGEND_HOR); 

// Display the graph
$graph->Stroke();
?>
