<?php
    require("php/prepend.php");
    
    // we need the xml parser
    require_once("./php/kxparse.php");
	    
    //load the file into the parser: constructor(string file)
    $xml_news=new kxparse("news.xml");
?>
<html>
 <head>
  <title>
   SetiStats
  </title>
  <link href="style.css" rel="stylesheet" type="text/css" />
  
 </head>

 <body>

  <!-- body table -->
  <table align="center" valign="top" border="0" cellpadding="8" cellspacing="0" width="85%">
   <!-- top header -->
   <tr>
    <td valign="center" width="25%" colspan="2">
    <?php
        @include("header.inc.php");
    ?>
    </td>
   </tr>
   <!-- end top header -->
 
   <tr>
    <!-- left column -->
    <td valign="top" width="25%">
     <?php
        require("navigation.inc.php");
     ?>
     <br />

    </td>
    <!-- end left column -->

    <!-- right column -->
    <td valign="top" width="75%">
     <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td valign="top" width="100%">

        <!-- story -->
        <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
         <tr>
          <td>
           <table border="0" cellpadding="8" cellspacing="1" width="100%">
            <tr>
             <td bgcolor="#ffffff">
              <h2>
               Neuigkeiten auf SetiStats
              </h2>

              <p>
	       Tja, was erwartet man wohl auf einer News-Page? :)
              </p>
	      
	      <p>
	       Also hier werde ich alles Neue rund um das Projekt "SetiStats" ver&ouml;ffentlichen.
	      </p>
	      
	      <?php
	      
		    if($mode=="all") {
			$lastelement = $xml_news->count_tag("news:item", "1:?");
		    } else {
			$lastelement = min(5, $xml_news->count_tag("news:item", "1:?"));
		    }
	    	    
		    if($lastelement == 0) {
			echo "<br/><p>Es wurden noch keine News eingetragen.</p>";
		    } else {
	    		for($n=1; $n <= $lastelement; $n++) {
			    echo "<h4>" . format_date($xml_news->get_tag_text("news:item:date","1:" . $n . ":1"), "de") . "</h4>\n<p>" . nl2br(htmlentities($xml_news->get_tag_text("news:item:message","1:" . $n . ":1"))) . "</p>\n";
			}
			if(($mode != "all") && ($xml_news->count_tag("news:item", "1:?") > $lastelement)) {
			    echo "<p>[ <a href=\"?mode=all\">Alle News anzeigen</a> ]</p>";
			}
		    }
	      ?>


             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
        <!-- end story -->

       </td>
      </tr>
     </table>
    </td>
    <!-- end right column -->
   </tr>
   <?php
    @include("footer.inc.php");
   ?>

  </table>
  <!-- end body table -->
 </body>
</html>
<?php
    require("php/append.php");
?>