<?php
    require("php/prepend.php");
?>
<html>
 <head>
  <title>
   SetiStats - der Einzel-Counter
  </title>
  <link href="style.css" rel="stylesheet" type="text/css" />
  
 </head>

 <body>
 <a name="top"></a>

  <!-- body table -->
  <table align="center" valign="top" border="0" cellpadding="8" cellspacing="0" width="85%">
   <!-- top header -->
   <tr>
    <td valign="center" width="25%" colspan="2">
    <?php
        @include("header.inc.php");
    ?>
    </td>
   </tr>
   <!-- end top header -->
 
   <tr>
    <!-- left column -->
    <td valign="top" width="25%">
     <?php
        require("navigation.inc.php");
     ?>
     <br />
     
     <!-- sidebox -->
     <table bgcolor="#000000" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td>
        <table border="0" cellpadding="3" cellspacing="1" width="100%">
         <tr>
          <td bgcolor="#cccccc">
          &nbsp;<a class="title" href="user.php#top">Page Index</a> 
          </td>
         </tr>
         <tr>
          <td bgcolor="#ffffff">
           &nbsp;<span class="small">o</span>
           <a class="nav" href="user.php#layouts">Layouts</a>
           <br />
           &nbsp;<span class="small">o</span>
           <a class="nav" href="user.php#config">Konfiguration</a>
           <br />
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
     <!-- end sidebox -->
     
     <br/>
     
     <!-- sidebox -->
     <table bgcolor="#000000" border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td>
        <table border="0" cellpadding="3" cellspacing="1" width="100%">
         <tr>
          <td bgcolor="#cccccc">
           &nbsp;<span class="title">Links</span>
          </td>
         </tr>
         <tr>
          <td bgcolor="#ffffff">
           &nbsp;<span class="small">o</span>
           <a class="nav" target="_blank" href="redirect.php?url=setiathome.ssl.berkeley.edu/account_area.html">Profil bei Seti</a>
           <br />
	   &nbsp;<span class="small">o</span>
           <a class="nav" href="redirect.php?url=www.setiathome.com" target="_blank">Seti@home</a>
           <br />
          </td>
         </tr>
        </table>
       </td>
      </tr>
     </table>
     <!-- end sidebox -->

    </td>
    <!-- end left column -->

    <!-- right column -->
    <td valign="top" width="75%">
     <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr>
       <td valign="top" width="100%">

        <!-- story -->
        <table align="center" bgcolor="#000000" border="0" cellPadding="0" cellSpacing="0" width="100%">
         <tr>
          <td>
           <table border="0" cellpadding="8" cellspacing="1" width="100%">
            <tr>
             <td bgcolor="#ffffff">
              <h2>
              Der User-Counter.
              </h2>
	      
	      <p>
	      <img src="userstats.php?bcolor=128,128,128&tcolor=128,128,128&l=2&email=1" border="0" hspace="15" vspace="10" align="left"> Der Counter stellt in Form eines kleinen Bildes eine &Uuml;bersicht ber den aktuellen Stand der berechneten Workunits dar und zeigt auch die Ver&auml;nderung der letzten 14 Tage an.
	      </p>
	      
	      <p>
	      Du kannst auf die Darstellung der Counter Einflu&szlig; nehmen, indem Du die Farbe der Schrift und des Rahmens variieren und aus verschiedenen Ansichten ausw&auml;hlen kannst.
	      </p>
	      
	      <p>
	       <b>Wichtig: </b><br/>Aktiviere in Deinem <a href="redirect.php?url=setiathome.ssl.berkeley.edu/account_area.html" target="_blank">Profil</a> bei <a href="redirect.php?url=www.setiathome.com" target="_blank">Seti@home</a> die Option "<i>Can we show your name on the SETI@home web site?</i>". Das ist notwendig, damit die Anzeige korrekt erfolgen kann.
	      </p>
	      
	      <a name="layouts"></a>
	      <h3>
               Die Layouts
              </h3>
	      <p>
	       Zuerst w&auml;hle das f&uuml;r Dich passenste Layout des Counters aus...
	      </p>
	      <form action="userstats_admin.php" method="post">
	      <p>
	    	    <table width="100%" border="0" cellpadding="0" cellspacing="0">
			<tr>
			    <td>
				<?php
				    $d = dir("layout/user");
				    while($entry=$d->read())
				    {
					if(is_file("layout/user/" . $entry))
					{
					    $layoutname = substr($entry, 0, strpos($entry, ".php"));
					    # perhaps we need some infos from inside the file
					    # require("layout/user/" . $entry);
					    
					    echo "<input type=\"radio\" name=\"layout\" value=\"$layoutname\"";
					    if($layout==$layoutname) { echo " checked"; }
					    echo "><img src=\"userstats.php?l=" . $layoutname . "\"><br>
\n&nbsp;<br/>\n";
					}
				    }
				?>
			    </td>
			</tr>
		    </table>
	      </p>
	      
	      
	      
	      
              <a name="config"></a>
	      <h3>
               Die Konfiguration
              </h3>
	      
	      <p>
	       Die Konfiguration des Counters erfolgt &uuml;ber Parameter bei dessen Aufruf. Da sich nun niemand alles M&ouml;gliche merken kann oder m&ouml;chte, habe ich ein kleines Frontend dazu geschrieben, welches Du nutzen kannst, um die verschiedenen Aspekte des Counters an Deine Bed&uuml;rfnisse anzupassen.
	      </p>
	      
	      <p>
	        <center><input type="submit" value="Konfigurieren &gt;"/></center>
	      </p>
	      
	      <p>
	       Dort bekommst Du auch eine Vorschau, &uuml;ber die Du Dir direkt ein Bild machen kannst, wie der Counter sp&auml;ter auf dem vorhandenen  Hintergrund aussieht.
	      </p>
	      
	      </form>

             </td>
            </tr>
           </table>
          </td>
         </tr>
        </table>
        <!-- end story -->
       </td>
      </tr>
     </table>
    </td>
    <!-- end right column -->
   </tr>
   <?php
    @include("footer.inc.php");
   ?>
  </table>
  <!-- end body table -->
 </body>
</html>
<?php
    require("php/append.php");
?>